class DocumentsController < ApplicationController
   before_filter :login_required
   live_tree :tree, :model => :document
   before_filter :project_required
   
     #show a document tree of a selected project (a project was selected before)
    def index
	@project = @session['project']
	@session['document'] = @root
        @root = Document.find(:first, :conditions => ["parent_id IS NULL AND project_id=?", @project.id])
    end
  
  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

#list all documents of a project (a project's id is known)
  def list
    @documents = Document.find(:all, :conditions => ['project_id =?', @session['project'].id])
  end

  def show
    @document = Document.find(params[:id])    
  end

  #create a new document
  def new
    @document = Document.new
    #list the project the user is working on
    @project = @session['project']
    #allow to choose a parent document by listing all documents of the chosen project
    @documents = Document.find(:all, :conditions => ["project_id=?", @project.id])
  end

  def create
    @document = Document.new(params[:document])
    #set document's project_id
    @document.project_id = @session['project'].id
    if @document.save
      flash[:notice] = 'Document was successfully created.'
      @paragraph = Paragraph.new
      @paragraph.document_id = @document.id
      redirect_to :action => 'index'
    else
      render :action => 'new'
    end
  end

  def edit
     #only allow to rename the document	  
    @document = Document.find(params[:id])
        
  end

  def update
    @document = Document.find(params[:id])
    if @document.update_attributes(params[:document])
      flash[:notice] = 'Document was successfully updated.'
      redirect_to :action => 'show', :id => @document
    else
      render :action => 'edit'
    end
  end

  #delete a document and all its children
  def destroy
    doc = Document.find(params[:id])
    Document.find(params[:id]).destroy
    #destroy the document and all its children
    Document.find(:all, :conditions => ["parent_id =?", doc.id]).each {|d| Document.find(d.id).destroy}
    redirect_to :action => 'index'
  end
  
  def modify
	@document = Document.find(params[:id])
	@saved = params[:saved]
	if @document.update_attributes(params[:document])
		flash[:notice] = 'Document was successfully saved.'
	end
	  
	  
  end
  
   #before accessing a document, a project must be selected
   protected
   def project_required
	if @session['project']
		return true
	end
	#require to select a project
	redirect_to :controller => 'projects', :action => 'index'
	return false
   end
end
